local L = AceLibrary("AceLocale-2.2"):new("Automaton_Summon")
Automaton_Summon = Automaton:NewModule("Summon", "AceEvent-2.0", "AceConsole-2.0", "AceDebug-2.0")
local module = Automaton_Summon

L:RegisterTranslations("enUS", function() return {
	["Summon"] = true,
	["Options for accepting summons."] = true,
	["Enabled"] = true,
	["Accept warlock or meeting stone summons automatically."] = true,
	["Delay"] = true,
	["With this option enabled, automatic summons are delayed for 100 seconds."] = true,
	["Accepting summon in 1:40..."] = true,
	["Accepting summon..."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Summon"] = "자동 소환",
	["Options for accepting summons."] = "소환에 관한 옵션을 설정합니다",
	["Enabled"] = "활성화",
	["Accept warlock or meeting stone summons automatically."] = "자동으로 흑마법사 또는 만남의 돌의 소환을 수락합니다.",
	["Delay"] = "지연",
	["With this option enabled, automatic summons are delayed for 100 seconds."] = "이 옵션이 활성화시, 자동 소환을 100초 동안 지연시킵니다.",
	["Accepting summon in 1:40..."] = "소환 수락 1:40...",
	["Accepting summon..."] = "소환 수락...",
} end)

L:RegisterTranslations("esES", function() return {
	["Summon"] = "Invocaci\195\179n",
	["Options for accepting summons."] = "Opciones para aceptar invocaciones",
	["Enabled"] = "Activado",
	["Accept warlock or meeting stone summons automatically."] = "Acepta las invocaciones de brujos o piedras de encuentro de forma autom\195\161tica",
	["Delay"] = "Retraso",
	["With this option enabled, automatic summons are delayed for 100 seconds."] = "Las invocaciones son retrasadas 100 segundos",
	["Accepting summon in 1:40..."] = "Aceptando invocaci\195\179n en 1:40m...",
	["Accepting summon..."] = "Aceptando invocaci\195\179n...",
} end)

module.description = L["Options for accepting summons."]
module.options = {
	delay = {
		type = 'toggle',
		name = L["Delay"],
		desc = L["With this option enabled, automatic summons are delayed for 100 seconds."],
		get = function() return module.db.profile.delay end,
		set = function(v) module.db.profile.delay = v end,
	},
}

function module:OnInitialize()
	self.db = Automaton:AcquireDBNamespace("Summon")
	Automaton:RegisterDefaults("Summon", "profile", {
		disabled = true,
		delay = true,
	})
	Automaton:SetDisabledAsDefault(self, "Summon")
	self:RegisterOptions(self.options)
end

function module:OnEnable()
	self:RegisterEvent("CONFIRM_SUMMON")
end

function module:Confirm()
	ConfirmSummon()
	StaticPopup_Hide("CONFIRM_SUMMON")
end

function module:CONFIRM_SUMMON()
	if module.db.profile.delay and not self:IsEventScheduled("module") then
		self:Print(L["Accepting summon in 1:40..."])
		self:ScheduleEvent("module", self.Confirm, 100, self)
	elseif not self:IsEventScheduled("module") then
		self:Print(L["Accepting summon..."])
		self:Confirm()
	end
end